within ;
package cv2


  connector yfcon
    Real y;
    flow Real f;
    annotation(Icon(graphics={  Rectangle(origin = {0, 1}, fillColor = {23, 184, 144},
              fillPattern =                                                                          FillPattern.Solid, extent = {{-96, 95}, {96, -95}})}), Diagram);
  end yfcon;

  model strop
    yfcon yfcon1 annotation(Placement(visible = true, transformation(origin = {2, -94}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {2, -94}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  parameter Real f = 1;
  constant Real PI = 3.14;
  Modelica.Blocks.Interfaces.RealInput u annotation(Placement(visible = true, transformation(origin = {-98, 78}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-84, 76}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
  equation
    yfcon1.y = u;
    annotation(Icon(graphics={  Rectangle(origin = {0, 4}, fillPattern = FillPattern.Solid, extent = {{-94, 90}, {94, -90}})}), Diagram(graphics = {Rectangle(origin=  {22, 7}, extent=  {{-80, 67}, {80, -67}})}));
  end strop;

  model kulicka "nejvic nejlepsi kulicka"
  yfcon yfcon1 annotation(Placement(visible = true, transformation(origin = {0, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {0, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Real a "velicina akcelerace";
    Real v;
    parameter Real m(unit = "kg", displayUnit = "g") = 1;
  Real y;
  equation
    v = der(yfcon1.y);
    yfcon1.y = y "trochu zbytecna rovnice";
    yfcon1.f = m * a;
    0 = der(v) - a;
    annotation(Icon(graphics={  Ellipse(origin = {0, -1}, lineColor = {7, 50, 1}, fillColor = {23, 107, 5},
              fillPattern =                                                                                               FillPattern.Sphere, extent = {{-92, 93}, {92, -93}}, endAngle = 360)}), Diagram);
  end kulicka;

  model pruzina
    yfcon yfcon1 annotation(Placement(visible = true, transformation(origin = {0, 94}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {0, 94}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  yfcon yfcon2 annotation(Placement(visible = true, transformation(origin = {6, -88}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {6, -88}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  parameter Real k = 1;
  equation
    yfcon1.y - yfcon2.y = yfcon1.f / k;
  yfcon1.f + yfcon2.f = 0;
    annotation(Icon(graphics={  Line(origin = {-4.09036, 3.20117}, points = {{0.0903637, 92.7988}, {-51.9096, 52.7988}, {54.0904, 50.7988}, {-67.9096, -11.2012}, {58.0904, -3.20117}, {-45.9096, -49.2012}, {68.0904, -51.2012}, {-37.9096, -81.2012}, {8.09036, -81.2012}, {8.09036, -93.2012}})}), Diagram);
  end pruzina;

  model objektove
    strop strop1 annotation(Placement(visible = true, transformation(origin = {-66, 74}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  kulicka kulicka1(m = 2)  annotation(Placement(visible = true, transformation(origin = {-20, 12}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  pruzina pruzina1 annotation(Placement(visible = true, transformation(origin = {-68, 40}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  cv2.pruzina pruzina2(k=2) annotation (Placement(visible=true, transformation(
          origin={36,-10},
          extent={{-10,-10},{10,10}},
          rotation=0)));
  kulicka kulicka2(m = 5)  annotation(Placement(visible = true, transformation(origin = {-22, -38}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  pruzina pruzina3(k = 100)  annotation(Placement(visible = true, transformation(origin = {-54, -66}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  kulicka kulicka3(m = 2)  annotation(Placement(visible = true, transformation(origin = {-6, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  equation
    connect(pruzina2.yfcon1, kulicka1.yfcon1) annotation(Line(points={{36,-0.6},
            {36,6.5},{-20,6.5},{-20,11.8}}));
    connect(pruzina2.yfcon2, kulicka2.yfcon1) annotation(Line(points={{36.6,
            -18.8},{-22,-18.8},{-22,-38.2}}));
    connect(pruzina3.yfcon2, kulicka3.yfcon1) annotation(Line(points={{-53.4,
            -74.8},{-6,-74.8},{-6,-80.2},{-6,-80.2}}));
    connect(pruzina3.yfcon1, kulicka2.yfcon1) annotation(Line(points={{-54,
            -56.6},{-22,-56.6},{-22,-38.2},{-22,-38.2}}));
    connect(pruzina1.yfcon2, kulicka1.yfcon1) annotation(Line(points={{-67.4,
            31.2},{-66,31.2},{-66,12},{-20,12},{-20,11.8}}));
    connect(strop1.yfcon1, pruzina1.yfcon1) annotation(Line(points={{-65.8,64.6},
            {-68,64.6},{-68,49.4},{-68,49.4}}));
    annotation(Icon, Diagram);
  end objektove;

  model system2
    strop strop1 annotation(Placement(visible = true, transformation(origin = {-24, 68}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  pruzina pruzina1 annotation(Placement(visible = true, transformation(origin = {-20, 14}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  kulicka kulicka1 annotation(Placement(visible = true, transformation(origin = {-50, -30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  kulicka kulicka2 annotation(Placement(visible = true, transformation(origin = {-8, -28}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  kulicka kulicka3 annotation(Placement(visible = true, transformation(origin = {32, -32}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  pruzina pruzina2 annotation(Placement(visible = true, transformation(origin = {-44, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    /*
          initial equation
          pruzina1.yfcon2.y = init_y;
          
        */
    kulicka_init kulicka_init1(y_start = 10)  annotation(Placement(visible = true, transformation(origin = {-90, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  equation
    connect(kulicka_init1.yfcon1, pruzina2.yfcon2) annotation(Line(points = {{-90, -20}, {-60, -20}, {-60, 20}, {-44, 20}, {-44, 22}}));
    connect(pruzina2.yfcon1, strop1.yfcon1) annotation(Line(points = {{-44, 40}, {-34, 40}, {-34, 54}, {-24, 54}, {-24, 58}, {-24, 58}}));
    connect(pruzina2.yfcon2, pruzina1.yfcon2) annotation(Line(points = {{-44, 22}, {-34, 22}, {-34, 6}, {-20, 6}, {-20, 6}}));
    connect(pruzina1.yfcon2, kulicka3.yfcon1) annotation(Line(points = {{-20, 6}, {36, 6}, {36, -32}, {32, -32}, {32, -32}}));
    connect(pruzina1.yfcon2, kulicka2.yfcon1) annotation(Line(points = {{-20, 6}, {-22, 6}, {-22, -28}, {-8, -28}, {-8, -28}}));
    connect(pruzina1.yfcon2, kulicka1.yfcon1) annotation(Line(points = {{-20, 6}, {-50, 6}, {-50, -30}, {-50, -30}}));
    connect(pruzina1.yfcon1, strop1.yfcon1) annotation(Line(points = {{-20, 24}, {-24, 24}, {-24, 58}, {-24, 58}}));
    annotation(Icon, Diagram);
  end system2;

  model kulicka_init
  yfcon yfcon1 annotation(Placement(visible = true, transformation(origin = {0, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {0, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    parameter Real y_start = 1;
  initial equation
    yfcon1.y = y_start;
  equation
    yfcon1.f = 0;
    annotation(Icon(coordinateSystem(initialScale = 0.1), graphics={  Rectangle(origin = {3, 1}, extent = {{-85, 91}, {85, -91}})}), Diagram);
  end kulicka_init;

  model rez
    strop strop1 annotation(Placement(visible = true, transformation(origin = {-8, 28}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  pruzina pruzina1(k = 6)  annotation(Placement(visible = true, transformation(origin = {0, -16}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  kulicka kulicka1(m = 11)  annotation(Placement(visible = true, transformation(origin = {0, -64}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Step step1(startTime = 1)  annotation(Placement(visible = true, transformation(origin = {-68, 34}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Sine sine1(freqHz = 0.111)  annotation(Placement(visible = true, transformation(origin = {-68, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  equation
    connect(sine1.y, strop1.u) annotation(Line(points={{-57,-10},{-40,-10},{-40,
            36},{-16,36},{-16,34},{-16,34},{-16,35.6},{-16.4,35.6}},                                                                                color = {0, 0, 127}));
    connect(pruzina1.yfcon2, kulicka1.yfcon1) annotation(Line(points={{0.6,
            -24.8},{0.6,-24.8},{0.6,-64.2},{0,-64.2}}));
    connect(strop1.yfcon1, pruzina1.yfcon1) annotation(Line(points={{-7.8,18.6},
            {-14,18.6},{-14,-6},{0,-6},{0,-6.6}}));
    annotation(Icon, Diagram);
  end rez;

  annotation (uses(Modelica(version="3.2.1")));
  package hydrodyn
    connector pqcon
      Real p(unit = "Pa");
      flow Real q(unit = "m3/s");
      annotation(Icon(graphics={  Rectangle(fillColor = {182, 37, 182},
                fillPattern =                                                         FillPattern.Solid, extent = {{-98, 98}, {98, -98}})}), Diagram);
    end pqcon;

    model balon
      cv2.hydrodyn.pqcon pqcon1 annotation (Placement(
          visible=true,
          transformation(
            origin={-88,90},
            extent={{-10,-10},{10,10}},
            rotation=0),
          iconTransformation(
            origin={4,-2},
            extent={{-10,-10},{10,10}},
            rotation=0)));
      parameter Real c "tuhost";
      Real vol "objem";
      parameter Real init_vol;
    initial equation
      vol = init_vol;
    equation
      der(vol) = pqcon1.q;
      pqcon1.p = c * vol;
      annotation(Icon(graphics={  Ellipse(origin = {4, -1}, extent = {{-94, 93}, {94, -93}}, endAngle = 360)}), Diagram);
    end balon;

    model odpor
      pqcon pqcon1 annotation(Placement(visible = true, transformation(origin = {-94, 6}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-94, 6}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      pqcon pqcon2 annotation (Placement(
          visible=true,
          transformation(
            origin={88,6},
            extent={{-10,-10},{10,10}},
            rotation=0),
          iconTransformation(
            origin={88,6},
            extent={{-10,-10},{10,10}},
            rotation=0)));
      parameter Real R;
    equation
      pqcon1.p - pqcon2.p = R * pqcon1.q;
      pqcon1.q + pqcon2.q = 0;
      annotation(Icon(graphics={  Rectangle(origin = {0, 3}, extent = {{-96, 33}, {96, -33}})}), Diagram);
    end odpor;

    model system
      balon balon1(c = 1, init_vol = 1)  annotation(Placement(visible = true, transformation(origin = {-82, 20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      odpor odpor1(R=1) annotation (Placement(visible=true, transformation(
            origin={-36,16},
            extent={{-10,-10},{10,10}},
            rotation=0)));
      balon balon2(c=2, init_vol=0) annotation (Placement(visible=true,
            transformation(
            origin={18,8},
            extent={{-10,-10},{10,10}},
            rotation=0)));
    equation
      connect(odpor1.pqcon2, balon2.pqcon1) annotation(Line(points={{-27.2,16.6},
              {0,16.6},{0,4},{18,4},{18,7.8},{18.4,7.8}}));
      connect(balon1.pqcon1, odpor1.pqcon1) annotation(Line(points={{-81.6,19.8},
              {-46,19.8},{-46,16.6},{-45.4,16.6}}));
      annotation(Icon, Diagram);
    end system;
    annotation(Icon, Diagram);
  end hydrodyn;
end cv2;
